# coding: utf-8

# GTO-MO-1-1 - Removed partial_header
# flake8: noqa

from datetime import date, datetime
import decimal
import functools
import io
import re
import typing
import typing_extensions
import uuid

import frozendict

from chkp_harmony_endpoint_management_sdk.generated.cloud import schemas


class BrowserExtensionSettings(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    class MetaOapg:
        
        class properties:
            pinToToolbar = schemas.BoolSchema
        
            @staticmethod
            def anonymousBrowsingMode() -> typing.Type['AnonymousBrowsingMode']:
                return AnonymousBrowsingMode
            
            
            class customSettings(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['CustomSetting']:
                        return CustomSetting
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['CustomSetting'], typing.List['CustomSetting']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'customSettings':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'CustomSetting':
                    return super().__getitem__(i)
            chromeExtensionId = schemas.StrSchema
            __annotations__ = {
                "pinToToolbar": pinToToolbar,
                "anonymousBrowsingMode": anonymousBrowsingMode,
                "customSettings": customSettings,
                "chromeExtensionId": chromeExtensionId,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["pinToToolbar"]) -> MetaOapg.properties.pinToToolbar: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["anonymousBrowsingMode"]) -> 'AnonymousBrowsingMode': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["customSettings"]) -> MetaOapg.properties.customSettings: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["chromeExtensionId"]) -> MetaOapg.properties.chromeExtensionId: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["pinToToolbar"], typing_extensions.Literal["anonymousBrowsingMode"], typing_extensions.Literal["customSettings"], typing_extensions.Literal["chromeExtensionId"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["pinToToolbar"]) -> typing.Union[MetaOapg.properties.pinToToolbar, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["anonymousBrowsingMode"]) -> typing.Union['AnonymousBrowsingMode', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["customSettings"]) -> typing.Union[MetaOapg.properties.customSettings, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["chromeExtensionId"]) -> typing.Union[MetaOapg.properties.chromeExtensionId, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["pinToToolbar"], typing_extensions.Literal["anonymousBrowsingMode"], typing_extensions.Literal["customSettings"], typing_extensions.Literal["chromeExtensionId"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        pinToToolbar: typing.Union[MetaOapg.properties.pinToToolbar, bool, schemas.Unset] = schemas.unset,
        anonymousBrowsingMode: typing.Union['AnonymousBrowsingMode', schemas.Unset] = schemas.unset,
        customSettings: typing.Union[MetaOapg.properties.customSettings, list, tuple, schemas.Unset] = schemas.unset,
        chromeExtensionId: typing.Union[MetaOapg.properties.chromeExtensionId, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'BrowserExtensionSettings':
        return super().__new__(
            cls,
            *_args,
            pinToToolbar=pinToToolbar,
            anonymousBrowsingMode=anonymousBrowsingMode,
            customSettings=customSettings,
            chromeExtensionId=chromeExtensionId,
            _configuration=_configuration,
        )

from chkp_harmony_endpoint_management_sdk.generated.cloud.model.anonymous_browsing_mode import AnonymousBrowsingMode
from chkp_harmony_endpoint_management_sdk.generated.cloud.model.custom_setting import CustomSetting
